SystemOrganization addCategory: #'Deltawerken-Documentation'!

Object subclass: #DEPaintings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Documentation'!

!DEPaintings methodsFor: 'classselection' stamp: 'StephanEggermont 9/11/2012 16:59'!
allClassesInPackagesStartingWith: aString
	|  packages classes |	
	packages := PackageInfo allPackages select: [ :p | p packageName beginsWith: aString  ].
	classes := OrderedCollection new.
	packages do: [ :p | classes addAll: (p classes reject: #isTrait) ].
	^classes! !

!DEPaintings methodsFor: 'classselection' stamp: 'StephanEggermont 9/11/2012 16:58'!
allDeltawerkenClasses
	|  packages classes |	
	packages := PackageInfo allPackages select: [ :p | p packageName beginsWith: 'Deltawerken-'  ].
	classes := OrderedCollection new.
	packages do: [ :p | classes addAll: (p classes reject: #isTrait) ].
	^classes! !

!DEPaintings methodsFor: 'mondrianpaintings' stamp: 'StephanEggermont 9/11/2012 17:10'!
distributionMap: aCollection on: aView
	|d|
	d := IdentityDictionary new.
	aCollection do: [:aClass | aClass methods do: [:m | d at: m put: m getSource lineCount ] ].

	aView shape rectangle withoutBorder.
	aView nodes: aCollection forEach: [ :each |
		aView shape label.
		aView node: each.
		aView node: each forIt: [
			aView shape rectangle size: 12;
				if: [:m | (d at: m) < 5 ] fillColor: Color green;
				if: [:m | (d at: m) >= 5 and: [ (d at: m) < 25 ] ] fillColor: Color orange;
				if: [:m | (d at: m) >= 25 ] fillColor: Color red.
			aView nodes: (each methods sortedAs: [:m | (d at: m) ]).
			aView gridLayout gapSize: 2 ].
			aView verticalLineLayout ].
	
	aView gridLayout
! !

!DEPaintings methodsFor: 'export' stamp: 'StephanEggermont 9/11/2012 17:07'!
exportPainting: aPaintingSelector of: aCollection on: aFilename
	|view form|
 	view := MOViewRenderer new.
	self perform: aPaintingSelector with: aCollection with: view.
	view root applyLayout.
	form := view getRenderedForm.
	PNGReadWriter putForm: form onFileNamed: aFilename.! !

!DEPaintings methodsFor: 'display' stamp: 'StephanEggermont 9/11/2012 17:24'!
openPainting: aPaintingSelector of: aCollection
	|view form|
 	view := MOViewRenderer new.
	self perform: aPaintingSelector with: aCollection with: view.
	view open! !

!DEPaintings methodsFor: 'display' stamp: 'StephanEggermont 9/11/2012 17:24'!
openPainting: aPaintingSelector of: aCollection on: aFilename
	|view form|
 	view := MOViewRenderer new.
	self perform: aPaintingSelector with: aCollection with: view.
	view open! !

!DEPaintings methodsFor: 'mondrianpaintings' stamp: 'StephanEggermont 9/11/2012 17:03'!
systemComplexity: aCollection on: aView
	aView shape rectangle
		width: [:cls | cls instVarNames size * 3];
		height: [:cls | cls methods size ];
		linearFillColor: [:cls | cls methods inject: 0 into: [:sum :el | sum + el getSource lineCount]] within: aCollection.
	aView nodes: aCollection.
	aView edgesFrom: #superclass.
	aView treeLayout.
! !
